/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.velocitycore.discord.channels;

import de.steamwar.sql.SchematicNode;
import de.steamwar.sql.SteamwarUser;
import de.steamwar.velocitycore.commands.CheckCommand;

import java.util.ArrayList;
import java.util.List;

public class ChecklistChannel extends DiscordChannel {

    private final List<Integer> lastSchematics = new ArrayList<>();

    public ChecklistChannel(String channel) {
        super(channel, 0);
    }

    public void update() {
        List<SchematicNode> schems = CheckCommand.getSchemsToCheck();

        lastSchematics.removeIf(id -> schems.stream().noneMatch(schem -> schem.getId() == id));
        schems.removeIf(schem -> lastSchematics.contains(schem.getId()));

        for (SchematicNode schem : schems) {
            String waitTime = "<t:" + (schem.getLastUpdate().getTime() / 1000) + ":R>";
            system("CHECK_LIST_TO_CHECK", waitTime, schem.getSchemtype().getKuerzel(), SteamwarUser.byId(schem.getOwner()).getUserName(), schem.getName());
            lastSchematics.add(schem.getId());
        }
    }
}
